unit help_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  Thelpform = class(TForm)
    helpbox: TPaintBox;
    subtitle: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    page1Btn: TSpeedButton;
    pageNrdisplay: TStaticText;
    ListBox1: TListBox;
    Timer1: TTimer;
    Label4: TLabel;
    procedure page1BtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure helpboxPaint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure pageNrdisplayMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pageNrdisplayMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure helpboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure helpboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure showhelp;

var
  helpform: Thelpform;

implementation

{$R *.dfm}

uses unit1;

const maxkolom = 60;
      maxpageregel = 25;  //0:subtitle; 1..24 tekst
      standardfont = 'Arial';
      regelhoogte = 24;
      standardheight = 20;
      largeheight = 24;
      smallheight = 17;
      standardcolor = $000000;
      altcolor = $00a000;
      standardbrush = $f0ffff;
      altbrush = $d8d8d8;
      standardstyles = [];
      coded = true;

      tab : array[0..7] of byte = (5, 3, 9, 13, 2, 7, 4, 12);//bit permutations

var regel : byte; //de regel op het scherm 1..24
    PageNr : byte; //1..
    maxpageNr : byte = 25;
    PagePointers : array[1..maxPageregel] of byte;
    ss : string;         //1 regel
    oldregel : byte = 0;

    oldx : word = 0;
    lineActive : boolean = false;
    oldr : byte = 1;

procedure showhelp;
begin
 with helpform do
  begin
   pageNr := 1;
   pageNrDisplay.color := standardbrush;
   pageNrDisplay.caption := inttostr(pageNr);
   maxpageNr := listbox1.Items.count div 25 + 1; //pages 1..
   showmodal;
  end;
end;

{
  help data processor
  25 regels tekst per scherm. regel 0 : subtitle  regel 1..24 tekst
}

function Helptekstdecode(s : string) : string;  //decode
var j, k, x : word;
       ss : string;
           y : byte;
begin
  ss := '';
  for j := 1 to length(s) div 2 do
  begin
   y := 0;
   x := ((ord(s[j*2]) - 20) shl 7) or (ord(s[j*2-1]) - 20);
   for k := 0 to 7 do
    if x and (1 shl tab[k]) <> 0 then y := y or (1 shl k);
   ss := ss + char(y);
  end;
  result := ss;
end;

procedure PageNormal;
begin
 with helpform.helpbox.canvas do
  begin
   pen.color := standardcolor;
   brush.color := standardbrush;
   brush.Style := bsClear;
   font.Name := standardfont;
   font.color := standardcolor;
   font.style := [];
   font.height := standardheight;
  end;
end;

procedure linemode(t : byte; var x,y : word);
//t=1: vertikaal  t=2: horizontaal t=0: end
begin
 if t = 0 then begin             //switch off
                lineActive := false;
                exit;
               end;
 if (t <>  1) and (not lineActive) then exit;
 with helpform.helpbox do
  with canvas do
   begin
    pen.width := 2;
    pen.color := $606060;
    pen.mode := pmCopy;
    case t of
            1 : begin                //vertikaal
                 if lineActive then
                  begin
                   moveto(oldx,y-5);
                   lineto(x,y-5);
                   moveto(oldx,y+25);
                   lineto(x,y+25);
                  end;
                  lineActive := true;
                  oldx := x;
                  moveto(oldx,y-5);
                  lineto(oldx,y+25);
                  x := x + 5;         //schuif cursor 5 op
                end;
            2 : begin                //horizontaal
                 moveto(oldx,y-5);
                 lineto(x,y-5);
                 moveto(oldx,y+25);
                 lineto(x,y+25);
                 oldx := x;
                end;
    end;//case
   end;//with
end;

procedure procPagePointer(n : byte); //pointer to character
var pnr , nn : byte;
begin
 pnr := 0;
 nn := 1;
 while (ss[n+nn] >= '0') and (ss[n+nn] <= '9') do
  begin
   pnr := pnr*10 + ord(ss[n+nn]) - ord('0');
   inc(nn);
  end;
  if nn > 0 then pagepointers[regel] := pnr;
end;

procedure Paintregel(ss : string);
var      i : byte;
     px,py : word;
        cc : char;
        dy : integer;
   controlmode : boolean;
   s : string;
begin
 if coded then s := helptekstdecode(ss)
  else s := ss;
 if regel = 0 then
  begin
   helpform.subtitle.caption := s;
   exit;
  end;
 dy := 0;
 px := 10; py := regel*regelhoogte;
 linemode(0,px,py); //switch off
 pageNormal;
 controlmode := false;
 with helpform.helpbox do
  with canvas do
  begin
   for i := 1 to length(s) do
    begin
     cc := s[i];
     if cc = '\' then controlmode := true
      else
       if controlmode then
        begin
         controlmode := false;
         case upcase(cc) of
                'C' : font.Name := 'courier new';
                'L' : begin
                       font.height := largeheight;
                       dy := 0;
                      end;
                'S' : begin
                       font.height := smallheight;
                       dy := 0;
                      end;
                'B' : begin
                       font.height := smallheight;
                       dy := 7;
                      end;
                'P' : begin
                       font.height := smallheight;
                       dy := -5;
                      end;
                'N' : begin
                       pageNormal;
                       dy := 0;
                       linemode(0,px,py);//uitschakelen
                      end;
                'F' : font.style := [fsbold];
                'M' : brush.color := altbrush;
                'T' : px := ((px div 150) + 1)*150;
                '[' : linemode(1,px,py);    //init
                'I' : font.style := [fsitalic];//ProcPagePointer(i);
         end;//case
        end //if controlmode
     else
     begin
      textout(px,py+dy,cc);
      linemode(2,px,py);                   //continue
      px := px + textwidth(cc);
     end;
    end;//for
  end;//with
end;

procedure Pageclear;
begin
 with helpform.helpbox do
  with canvas do
   begin
    brush.color := standardbrush;
    fillrect(rect(5,5,width-5,height-5));
   end;
end;

procedure showpage;
var base : word;
       i : byte;
begin
   regel := 0;
   base := (pageNr-1) * maxpageregel;
   for i := 1 to maxpageregel do pagePointers[i] := 0;
   oldregel := 0;
   while (base+regel < helpform.listbox1.items.count)
            and (regel < maxpageregel) do
    begin
     ss := helpform.listbox1.items.strings[base+regel];
     paintregel(ss);
     inc(regel);
    end;
end;

{-------system interface-----}

procedure THelpform.helpboxPaint(Sender: TObject);
var i : byte;
begin
 with helpbox do
  with canvas do
   begin
    brush.color := standardbrush;
    fillrect(rect(0,0,width,height));
    for i := 0 to 2 do
     begin
      pen.color := $0;
      moveto(width-1-i,i);
      lineto(i,i); lineto(i,height-1-i);
      pen.color := $f0f0f0;
      lineto(width-1-i,height-1-i);
      lineto(width-1-i,i);
     end;//for
   end; //with
 ShowPage;
end;

procedure THelpform.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key = #27 then begin
                    key := #0;
                    modalresult := mrOK;
                   end;
end;

procedure Nextpage(rr : byte); //1 up,2 down, 0 repeat
begin
 if rr <> 0 then oldr := rr;
 if (oldr = 1) and (pageNr < maxPageNr) then inc(pageNr)
  else if (oldr = 2) and (pagenr > 1) then dec(pageNr)
   else exit;
 PageClear;
 helpform.pageNrDisplay.caption := IntToStr(PageNr);
 showpage;
end;

procedure THelpform.pageNrDisplayMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var rr : byte;
begin
 rr := 1; if button = mbRight then rr := 2; //up/down
 NextPage(rr);
 timer1.enabled := true;
end;

procedure THelpform.Timer1Timer(Sender: TObject);
begin
 nextpage(0);
end;

procedure THelpform.pageNrDisplayMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 timer1.enabled := false;
end;

procedure Page1;
begin
 PageClear;
 pageNr := 1;
 helpForm.pageNrDisplay.caption := IntToStr(PageNr);
 showpage;
end;

procedure THelpForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var r : byte;
begin
 r := 0;
 if key = 33 then r := 2
  else if key = 34 then r := 1;
 if r <> 0 then nextpage(r);
 if key = VK_HOME then page1;
end;

procedure THelpForm.page1BtnClick(Sender: TObject);
begin
 page1;
end;

procedure HIregel(rr : byte);
//geef regel rr een kleurtje
var i : byte;
begin
 with helpForm.helpbox do
  with canvas do
   begin
    pen.color := $a00000;
    pen.width := 1;
    pen.mode := pmMergePenNot;
    for i := 0 to 19 do
     begin
      moveto(10,rr*regelhoogte + i); lineto(width-10,rr*regelhoogte+i);
     end;
   end;
end;

procedure THelpForm.helpboxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var regelNr : byte;
begin
 regelNr := y div regelhoogte;
 if regelNr = oldregel then exit;
 if oldregel <> 0 then begin
                        HIregel(oldregel);   //oude regel herstellen
                        oldregel := 0;
                       end;
 if (regelNr > 0) and (regelNr < 25) and (pagepointers[regelNr] <> 0)then
  begin
   HIregel(regelNr);
   oldRegel := regelNr;
  end;
end;

procedure THelpForm.helpboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if oldregel <> 0 then begin
                        pagenr := pagepointers[oldregel];
                        pageclear;
                        showpage;
                        pageNrDisplay.caption := IntToStr(PageNr);
                       end;
end;

end.

